unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

const
  BallCount = 33; // Max BallCount==63;
  VCount =(((((((((BallCount * (BallCount - 1)) div 2) * (BallCount - 2)) div 3) * (BallCount - 3)) div 4) *
    (BallCount - 4)) div 5) * (BallCount - 5)) div 6;

type
  TDataList = array [0 .. VCount - 1] of UInt64;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    DA: TDataList;
    procedure EnumAllValues(var DA: TDataList);
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses System.Threading, System.SyncObjs, System.Diagnostics;

const
  MoveMask: array [0 .. 63] of UInt64 = (
    1,
    UInt64(1) shl 1,
    UInt64(1) shl 2,
    UInt64(1) shl 3,
    UInt64(1) shl 4,
    UInt64(1) shl 5,
    UInt64(1) shl 6,
    UInt64(1) shl 7,
    UInt64(1) shl 8,
    UInt64(1) shl 9,
    UInt64(1) shl 10,
    UInt64(1) shl 11,
    UInt64(1) shl 12,
    UInt64(1) shl 13,
    UInt64(1) shl 14,
    UInt64(1) shl 15,
    UInt64(1) shl 16,
    UInt64(1) shl 17,
    UInt64(1) shl 18,
    UInt64(1) shl 19,
    UInt64(1) shl 20,
    UInt64(1) shl 21,
    UInt64(1) shl 22,
    UInt64(1) shl 23,
    UInt64(1) shl 24,
    UInt64(1) shl 25,
    UInt64(1) shl 26,
    UInt64(1) shl 27,
    UInt64(1) shl 28,
    UInt64(1) shl 29,
    UInt64(1) shl 30,
    UInt64(1) shl 31,
    UInt64(1) shl 32,
    UInt64(1) shl 33,
    UInt64(1) shl 34,
    UInt64(1) shl 35,
    UInt64(1) shl 36,
    UInt64(1) shl 37,
    UInt64(1) shl 38,
    UInt64(1) shl 39,
    UInt64(1) shl 40,
    UInt64(1) shl 41,
    UInt64(1) shl 42,
    UInt64(1) shl 43,
    UInt64(1) shl 44,
    UInt64(1) shl 45,
    UInt64(1) shl 46,
    UInt64(1) shl 47,
    UInt64(1) shl 48,
    UInt64(1) shl 49,
    UInt64(1) shl 50,
    UInt64(1) shl 51,
    UInt64(1) shl 52,
    UInt64(1) shl 53,
    UInt64(1) shl 54,
    UInt64(1) shl 55,
    UInt64(1) shl 56,
    UInt64(1) shl 57,
    UInt64(1) shl 58,
    UInt64(1) shl 59,
    UInt64(1) shl 60,
    UInt64(1) shl 61,
    UInt64(1) shl 62,
    UInt64(1) shl 63
  );

procedure EnumValue(Base: UInt64; BaseIndex: Integer; var DataList: TDataList;
  var Count: Integer); inline;
var
  j, k, L, M, N: UInt64;
begin
  for j := 4 to BaseIndex - 1 do
  begin
    Base := Base + MoveMask[j];
    DataList[Count] := Base;
    Inc(Count);
    for k := 3 to j - 1 do
    begin
      Base := Base + MoveMask[k];
      DataList[Count] := Base;
      Inc(Count);
      for L := 2 to k - 1 do
      begin
        Base := Base + MoveMask[L];
        DataList[Count] := Base;
        Inc(Count);
        for M := 1 to L - 1 do
        begin
          Base := Base + MoveMask[M];
          DataList[Count] := Base;
          Inc(Count);
          for N := 0 to M - 1 do
          begin
            Base := Base + MoveMask[N];
            DataList[Count] := Base;
            Inc(Count);
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.EnumAllValues(var DA: TDataList);
var
  i, Count: Integer;
  Base: UInt64;
begin
  // ׼
  Base := $3F; // 6λ1
  DA[0] := Base;
  Count := 1;

  for i := 5 to BallCount - 2 do
  begin
    Base := Base + MoveMask[i];
    DA[Count] := Base;
    Inc(Count);
    EnumValue(Base, i, DA, Count);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
  st: TStopWatch;
begin
  TThread.Current.Priority:=TThreadPriority.tpTimeCritical;
  st := TStopWatch.Create;
  st.Reset;
  st.Start;
  for i := 0 to 999 do
    EnumAllValues(DA);
  st.Stop;
  TThread.Current.Priority:=TThreadPriority.tpNormal;
  ShowMessage(Format('1000 TimesAverage Time:%f ms', [st.ElapsedMilliseconds/1000.0]));
//  ShowMessage(Format('Elapsed Time:%d ms', [st.ElapsedMilliseconds]));
end;
end.
